<?php

namespace Onestartup\FacturaDigital;

use Illuminate\Support\ServiceProvider;
use Onestartup\FacturaDigital\Lib\Factura;
use Onestartup\FacturaDigital\Lib\FacturaConcepto;
use Onestartup\FacturaDigital\Lib\FacturaConceptoLista;
use Onestartup\FacturaDigital\Lib\FacturaReceptor;
use Onestartup\FacturaDigital\Lib\FacturaImpuesto;
use Onestartup\FacturaDigital\Lib\FacturaEmisor;


class FacturaDigitalProvider extends ServiceProvider
{
    /**
     * Bootstrap the application services.
     *
     * @return void
     */
    public function boot()
    {
        
    }

    /**
     * Register the application services.
     *
     * @return void
     */
    public function register()
    {
        $this->app->bind('factura-digital', function ()
        {
            return new Factura(
                new FacturaConcepto(), 
                new FacturaConceptoLista(), 
                new FacturaReceptor(), 
                new FacturaImpuesto(), 
                new FacturaEmisor()
            );
        });
    }
}
