<?php

namespace  Onestartup\FacturaDigital\Lib;

class FacturaConcepto
{
	
	private $ClaveProdServ;
	private $NoIdentificacion;
	private $Cantidad;
	private $ClaveUnidad;
	private $Unidad;
	private $Descripcion;
	private $ValorUnitario;
	private $Importe;
	private $Descuento;
	private $Impuesto='002';
	private $ImpuestoBase;
	private $ImpuestoTipoFactor='Tasa';
	private $ImpuestoTasaOCuota='0.160000';
	private $ImpuestoImporte;
	private $data;
    private $traslado;
    private $CalculoManual = false;

    /**
     * @return mixed
     */
    public function getClaveProdServ()
    {
        return $this->ClaveProdServ;
    }

    /**
     * @param mixed $ClaveProdServ
     *
     * @return self
     */
    public function setClaveProdServ($ClaveProdServ)
    {
        $this->ClaveProdServ = $ClaveProdServ;
        $this->data['ClaveProdServ'] = $ClaveProdServ;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getNoIdentificacion()
    {
        return $this->NoIdentificacion;
    }

    /**
     * @param mixed $NoIdentificacion
     *
     * @return self
     */
    public function setNoIdentificacion($NoIdentificacion)
    {
        $this->NoIdentificacion = $NoIdentificacion;
        $this->data['NoIdentificacion'] = $NoIdentificacion;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getCantidad()
    {
        return $this->Cantidad;
    }

    /**
     * @param mixed $Cantidad
     *
     * @return self
     */
    public function setCantidad($Cantidad)
    {
        $this->Cantidad = $Cantidad;
        $this->data['Cantidad'] = number_format($Cantidad, 0, '.', '');
        return $this;
    }

    /**
     * @return mixed
     */
    public function getClaveUnidad()
    {
        return $this->ClaveUnidad;
    }

    /**
     * @param mixed $ClaveUnidad
     *
     * @return self
     */
    public function setClaveUnidad($ClaveUnidad)
    {
        $this->ClaveUnidad = $ClaveUnidad;
        $this->data['ClaveUnidad'] = $ClaveUnidad;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getUnidad()
    {
        return $this->Unidad;
    }

    /**
     * @param mixed $Unidad
     *
     * @return self
     */
    public function setUnidad($Unidad)
    {
        $this->Unidad = $Unidad;
        $this->data['Unidad'] = $Unidad;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getDescripcion()
    {
        return $this->Descripcion;
    }

    /**
     * @param mixed $Descripcion
     *
     * @return self
     */
    public function setDescripcion($Descripcion)
    {
        $this->Descripcion = $Descripcion;
        $this->data['Descripcion'] = $Descripcion;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getValorUnitario()
    {
        return $this->ValorUnitario;
    }

    /**
     * @param mixed $ValorUnitario
     *
     * @return self
     */
    public function setValorUnitario($ValorUnitario)
    {
        $this->ValorUnitario = $ValorUnitario;

        $valor_final = $this->getCalculoManual() ? $this->ValorUnitario : $this->precioSinIva($ValorUnitario);

        if (!$this->getCalculoManual()) {
            $importe = $valor_final * $this->getCantidad();
            $this->setImpuesto('002');
            $this->setImpuestoTipoFactor('Tasa');
            $this->setImporte($importe);
            $this->setImpuestoBase($importe);
            $this->setImpuestoTasaOCuota('0.160000');
            $this->setImpuestoImporte($importe * $this->getImpuestoTasaOCuota());
        }

        $this->data['ValorUnitario'] = number_format($valor_final, 2, '.', '');
        
        return $this;
    }

    /**
     * @return mixed
     */
    public function getImporte()
    {
        return $this->Importe;
    }

    /**
     * @param mixed $Importe
     *
     * @return self
     */
    public function setImporte($Importe)
    {
        $this->Importe = $Importe;
        $this->data['Importe'] = number_format($Importe, 2, '.', '');
        return $this;
    }

    /**
     * @return mixed
     */
    public function getDescuento()
    {
        return $this->Descuento;
    }

    /**
     * @param mixed $Descuento
     *
     * @return self
     */
    public function setDescuento($Descuento)
    {
        $this->Descuento = $Descuento;
        $this->data['Descuento'] = number_format($Descuento, 2, '.', '');
        return $this;
    }

    /**
     * @return mixed
     */
    public function getImpuestoBase()
    {
        return $this->Base;
    }

    /**
     * @param mixed $Base
     *
     * @return self
     */
    public function setImpuestoBase($Base)
    {
        $this->Base = $Base;
        $this->traslado['Base'] = number_format($Base, 2, '.', '');
        return $this;
    }

    /**
     * @return mixed
     */
    public function getImpuesto()
    {
        return $this->Impuesto;
    }

    /**
     * @param mixed $Impuesto
     *
     * @return self
     */
    public function setImpuesto($Impuesto)
    {
        $this->Impuesto = $Impuesto;
        $this->traslado['Impuesto'] = $Impuesto;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getImpuestoTipoFactor()
    {
        return $this->TipoFactor;
    }

    /**
     * @param mixed $TipoFactor
     *
     * @return self
     */
    public function setImpuestoTipoFactor($TipoFactor)
    {
        $this->TipoFactor = $TipoFactor;
        $this->traslado['TipoFactor'] = $TipoFactor;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getImpuestoTasaOCuota()
    {
        return $this->TasaOCuota;
    }

    /**
     * @param mixed $TasaOCuota
     *
     * @return self
     */
    public function setImpuestoTasaOCuota($TasaOCuota)
    {
        $this->TasaOCuota = $TasaOCuota;
        $this->traslado['TasaOCuota'] = number_format($TasaOCuota, 6, '.', '');
        return $this;
    }

     /**
     * @return mixed
     */
     public function getImpuestoImporte()
     {
        return $this->TasaOCuota;
    }

    /**
     * @param mixed $TasaOCuota
     *
     * @return self
     */
    public function setImpuestoImporte($Importe)
    {
        $this->Importe = $Importe;
        $this->traslado['Importe'] = number_format($Importe, 2, '.', '');
        return $this;
    }

    public function __toString()
    {
    	return (array)$this;
    }

    public function getData()
    {
        return array_merge($this->data, [
            'Impuestos'=>[
                'Traslados'=> [$this->traslado]
            ]
        ]);
    }

    /**
     * @return mixed
     */
    public function getCalculoManual()
    {
        return $this->CalculoManual;
    }

    /**
     * @param boolean $CalculoManual
     *
     * @return self
     */
    public function setCalculoManual($CalculoManual)
    {
        $this->CalculoManual = $CalculoManual;
        return $this;
    }

    public function precioSinIva($precioConIva)
    {
        $data = [];
        $precioSin = $precioConIva / 1.16;

        return $precioSin;
    }




}
